<id>
User Display name History
</id>

<version>
0.6
</version>

<mod info>
This mod creates a Display Name History if user changes their Display Name.

Installation:
=============
Install using YaBMod

Mod History:
=============
0.6 - Update for YaBB 2.7.00 ( Feb 19, 2016 )
0.5 - Update for YaBB 2.6.11 ( Dec 13, 2014 )
0.4 - Update for YaBB 2.6.1 ( Nov 29, 2014 )
0.3 - Update for YaBB 2.6.1 ( Sep 4, 2014 )
2.6 - Update for YaBB 2.6.0 ( Feb 25, 2014 )
2.5 - Update for YaBB 2.5AE ( July 4th, 2010 )
2.4 - Update for YaBB 2.4 ( April 18th, 2009 )

</mod info>

<author>
Boris Tjuvanov (MF-B), Jeffrey Man (Jet Li) and Detlef Pilzecker (deti) - 2.6.1-2.7.00 updates by DA Rorabaugh (Dandello)
</author>

<homepage>
http://www.yabbforumsoftware.com.net/cgi-bin/yabb2/YaBB.pl
</homepage>

<edit file>
Admin/ModList.pm
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
## Added for Display Name History Mod ##
    $DisplayNameHistory = 'Display_Name_History|Boris Tjuvanov (MF-B) and Jeffrey Man (Jet Li). 2.7.00 DA Rorabaugh (Dandello)|This mod creates a Display Name History if user changes their Display Name.|0.6|02/19/2016|';
    push @installed_mods, $DisplayNameHistory;
</add before>

<edit file>
Admin/NewSettings.pm
</edit file>

<search for>
if (@newsettingspmmods) {
</search for>

<add before>
push @newsettingspmmods, 'Display Name History';
</add before>

<search for>
1;
EOF
</search for>

<add before>
\$UNDH_level = $UNDH_level;                    # minimum user level for show Display Name History: 1 = members, 2 = mods, 3 = gmod, 4= admin
</add before>

<edit file>
Admin/Settings_Main.pm
</edit file>

<search for>
        {
            description => qq~<label for="usertools">$admin_txt{'526'}</label>~,
            input_html => qq~<input type="checkbox" name="usertools" id="usertools" value="1"${ischecked($usertools)} />~,
            name => 'usertools',
            validate => 'boolean',
        },
</search for>

<add after>
        { # User Display name History MOD START
            description => qq~<label for="UNDH_level">$admin_txt{'526b'}</label>~,
            input_html => qq~
            <select name="UNDH_level" id="UNDH_level">
                <option value="1" ${isselected($UNDH_level == 1)}>$userlevel_txt{'members'}</option>
                <option value="2" ${isselected($UNDH_level == 2)}>$userlevel_txt{'modgmodadmin'}</option>
                <option value="3" ${isselected($UNDH_level == 3)}>$userlevel_txt{'gmodadmin'}</option>
                <option value="4" ${isselected($UNDH_level == 4)}>$userlevel_txt{'admin'}</option>
            </select>~,
            name => 'UNDH_level',
            validate => 'number',
        }, # User Display name History MOD END
</add after>

<edit file>
Languages/English/Admin.lng
</edit file>

<search for>
if (@englishadminlngmods) {
</search for>

<add before>
push @englishadminlngmods, 'Display Name History';
</add before>

<search for>
1;
</search for>

<add before>
$admin_txt{'526b'} = 'Show Display Name History for'; # User Display name History MOD
</add before>

<edit file>
Languages/English/Profile.lng
</edit file>

<search for>
if (@englishprofilelngmods) {
</search for>

<add before>
push @englishprofilelngmods, 'Display Name History';
</add before>

<search for>
1;
</search for>

<add before>
# User Display name History MOD START
$profile_txt{'udnh1'} = 'Display Name History';
$profile_txt{'udnh2'} = 'Changed from';
$profile_txt{'udnh3'} = 'Into';
$profile_txt{'udnh4'} = 'Date of change(s)';
$profile_txt{'udnh5'} = 'Close Window';
$profile_txt{'udnh6'} = 'Last 10 changes';
# User Display name History MOD END

</add before>

<edit file>
Sources/Profile.pm
</edit file>

<search for>
if (@profilepmmods) {
</search for>

<add before>
push @profilepmmods, 'Display Name History';
</add before>

<search for>
        $yySetLocation =
qq~$scripturl?action=$scriptAction;username=$useraccount{$member{'username'}};sid=$INFO{'sid'}~;
</search for>

<add before>
        if ($member{'name'} ne $member{'oldname'}) { UDNameHistoryWrite($user,$member{'oldname'},$member{'name'}); } # User Display name History MOD
</add before>

<search for>
    $showProfile .= $myshow_profile;
</search for>

<add before>
    # User Display name History MOD START
    if (
        ${ $uid . $user }{'unamehistory'}
        && (
            $UNDH_level == 1
            || ( $UNDH_level == 2
                && ( $iammod || $iamfmod || $iamgmod || $iamadmin ) )
            || ( $UNDH_level == 3 && ( $iamfmod || $iamgmod || $iamadmin ) )
            || ( $UNDH_level == 4 && ( $iamgmod || $iamadmin ) )
            || ( $UNDH_level == 5 && $iamadmin )
        )
      )
    {
        $unamehistory = qq~
        <script type="text/javascript">
        function NHistory(udnh) {
        window.open('$scripturl?action=udnhistory;user='+udnh, '', 'menubar=no,toolbar=no,top=50,left=50,scrollbars=yes,resizable=no,width=550,height=340');
        }
         </script>
        <a href="javascript:void(0);" onclick="NHistory('$useraccount{$user}');">$profile_txt{'udnh1'}</a><br />
        ~;
    }
    # User Display name History MOD END

</add before>

<search for>
## Mod Hook showProfile2 ##
</search for>

<add before>
    $showProfile =~ s/{yabb unamehistory}/$unamehistory/sm;
</add before>

<search for>
1;
</search for>

<add before>
# User Display name History MOD START
sub UDNameHistoryWrite {
    my ( $usern, $useroldn, $usernewn ) = @_;
    my $datahist = time;
    my $unhistory = qq~$useroldn|$usernewn|$datahist~;

    if (!${$uid.$usern}{'unamehistory'}) {
        ${$uid.$usern}{'unamehistory'} = "$unhistory";
    } else {
        my @currentHistoryList = split /\/\//xsm, ${$uid.$usern}{'unamehistory'};
        push(@currentHistoryList, $unhistory);
        my $count = @currentHistoryList;
        if ($count > 10) { shift(@currentHistoryList) }
        $newHistoryList = join '//', @currentHistoryList;
        ${$uid.$usern}{'unamehistory'} = "$newHistoryList";
    }
    UserAccount($usern, 'update');
}

sub UDNameHistory {
    my $usernhitory = $INFO{'user'};
    if (!$usernhitory) { exit; }
    if ($do_scramble_id) { $usernhitory = decloak($usernhitory); }
    if (!${$uid.$usernhitory}{'password'}) { LoadUser($usernhitory); }
    my @udnhistory = split /\/\//xsm, ${ $uid . $usernhitory }{'unamehistory'};

    foreach my $member (@udnhistory) {
        my ( $uoldn, $unewn, $udata ) = split /\|/xsm, $member;
        $udata = timeformat($udata);
        $undh_history .= $undh_show_in;
        $undh_history =~ s/{yabb uoldn}/$uoldn/sm;
        $undh_history =~ s/{yabb unewn}/$unewn/sm;
        $undh_history =~ s/{yabb udata}/$udata/sm;
    }
    $output = $undh_show;
    $output =~ s/{yabb undh_history}/$undh_history/sm;

    print_output_header();
    print_HTML_output_and_finish();
    return;
}
# User Display name History MOD END
</add before>

<edit file>
Sources/SubList.pm
</edit file>

<search for>
if (@sublistpmmods) {
</search for>

<add before>
push @sublistpmmods, 'Display Name History';
</add before>

<search for>
1;
</search for>

<add before>
$director{'udnhistory'} = 'Profile.pm&UDNameHistory'; # User Display name History MOD
</add before>

<edit file>
Sources/System.pm
</edit file>

<search for>
   ## Mod hook ##
</search for>

<add before>
    push @tags, 'unamehistory'; # User Display name History MOD
</add before>

<edit file>
Templates/default/MyProfile.template
</edit file>

<search for>
if (@defaultmyprofilemods) {
</search for>

<add before>
push @defaultmyprofilemods, 'Display Name History';
</add before>

<search for>
             <input type="text" maxlength="30" onchange="checkAvail('$scripturl',this.value,'display')" name="name" id="name" size="30" value="{yabb user}" /><div id="displayavailability"></div>
</search for>

<replace>
            <input type="text" maxlength="30" onchange="checkAvail('$scripturl',this.value,'display')" name="name" size="30" value="{yabb user}" /><div id="displayavailability"></div><input type="hidden" name="oldname" value="{yabb user}" />
</replace>

<search for>
            <span style="font-size: 18px;">{yabb realname}</span><br />
</search for>

<add after>
            {yabb unamehistory}
</add after>

<search for>

1;
</search for>

<add before>
##Display Name History
 
$undh_show = qq~<!DOCTYPE html>
<html lang="$abbr_lang">
<head>
<!-- YaBB 2.7.00 $Revision: 0.6 -->
<meta charset=$yymycharset">
<title>$profile_txt{'udnh1'}</title>
<link rel="stylesheet" href="$yyhtml_root/Templates/Forum/$usestyle.css" type="text/css" />
</head>
<body style="min-width: 500px;">
<table class="bordercolor pad_4px cs_thin">
    <tr>
        <td class="titlebg center" colspan="3"><b>$profile_txt{'udnh1'}</b><br />$profile_txt{'udnh6'}</td>
    </tr><tr>
        <td class="catbg">$profile_txt{'udnh2'}</td>
        <td class="catbg">$profile_txt{'udnh3'}</td>
        <td class="catbg">$profile_txt{'udnh4'}</td>
    </tr>
    {yabb undh_history}
    <tr>
        <td class="windowbg center" colspan="3"><a href="javascript:window.close();">$profile_txt{'udnh5'}</a></td>
    </tr>
</table>
</body>
</html>~;

$undh_show_in = q~<tr>
        <td class="windowbg2">{yabb uoldn}</td>
        <td class="windowbg2">{yabb unewn}</td>
        <td class="windowbg2">{yabb udata}</td>
    </tr>~;
</add before>